#include <iostream>
#include "prng.h"

void printHelp();
PRNG prng;

int main(int argc, char *argv[])
{
    if(argc > 1)
    {
        int selection = static_cast<int>(*argv[1]) - 48;
        switch(selection)
        {
            // Output an endless stdout stream of random values using the selected algorithm
            case 0: while(1) std::cout << static_cast<char>(prng.getMersenne());
            case 1: while(1) std::cout << static_cast<char>(prng.getXoroshiro());
            case 2: while(1) std::cout << static_cast<char>(prng.getPcg());
            case 3: while(1) std::cout << static_cast<char>(prng.getJkiss32());
            case 4: while(1) std::cout << static_cast<char>(prng.getP2Lfsr());
            default: printHelp(); break;
        };
    }
    else
    {
        printHelp();
    }
}

void printHelp()
{
    std::cout << "Usage: PP2PE <nr>" << std::endl << std::endl;
    std::cout << "0: Generate an endless stdout stream of random bytes using Mersenne Twister" << std::endl;
    std::cout << "1: Generate an endless stdout stream of random bytes using Xoroshiro 128+" << std::endl;
    std::cout << "2: Generate an endless stdout stream of random bytes using PCG" << std::endl;
    std::cout << "3: Generate an endless stdout stream of random bytes using JKISS32" << std::endl;
    std::cout << "4: Generate an endless stdout stream of random bytes using standard P2 LFSR" << std::endl << std::endl;
}
